SystemOrganization addCategory: #'tODE-Views'!

!Collection methodsFor: '*tode-views' stamp: 'dkh 5/28/2011 10:32'!
tODEInspectorFields
	<tODEInspectorFields>
	| i |
	i := 0.
	^ self asArray
		collect: [ :each | 
			i := i + 1.
			(TOInspectorKeylessFieldSpec new)
				keyLabel: i printString;
				value: each ]! !

!TestCase class methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 14:52'!
renderTestTabOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!TestCase class methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 14:52'!
tODETestCaseTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #testCase;
		rendererClass: TOTestCase;
		receiver: self;
		label: 'tests';
		order: 80;
		group: 'development';
		renderSelector: #renderTestTabOn:spec:tOdeMain:! !

!Association methodsFor: '*tode-views' stamp: 'dkh 5/28/2011 10:52'!
asKeylessFieldSpec
	^ (TOInspectorKeylessFieldSpec new)
		keyLabel: key;
		value: value! !

!Dictionary methodsFor: '*tode-views' stamp: 'dkh 5/28/2011 10:12'!
tODEInspectorFields
	<tODEInspectorFields>
	^ self associations
		collect: [ :assoc | 
			(TOInspectorFieldSpec new)
				key: assoc key;
				value: assoc value ]! !

TOView subclass: #TOCodeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

TOCodeBrowser subclass: #TOClassBrowser
	instanceVariableNames: 'classDefinition classTemplate'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOClassBrowser methodsFor: 'accessing' stamp: 'dkh 5/23/2011 19:04'!
classDefinition

	classDefinition ifNil: [ classDefinition := self classDefinitionTemplate: self classTemplate ].
	^ classDefinition! !

!TOClassBrowser methodsFor: 'accessing' stamp: 'dkh 5/23/2011 18:31'!
classDefinition: anObject
	classDefinition := anObject! !

!TOClassBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 00:08'!
classTemplate
	"#explorer, #definition, #subclass or #new"
	
	classTemplate ifNil: [ classTemplate := #explorer ].
	^classTemplate ! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/23/2011 23:53'!
renderClassDefinitionOn: html main: main

	self 
		renderControl: [ :id :scrpt |
			html textArea
				id: id;
				columns: 80;
				rows: self classDefinition lineCount + 1;
				value: self classDefinition ;
				onKeyUpMap: {
					17 "ctl" -> (html jQuery ajax
						script: [:s | ctlKeyPressed := false ])};
				onKeyDownMap: {
					17 "ctl" -> (html jQuery ajax
						script: [:s | ctlKeyPressed := true ]).
					83 "s"-> (html jQuery ajax
					callback: [ :value | classDefinition := value .  ] value: (html jQuery id: id) value;
						script: [:s | 
							ctlKeyPressed 
								ifTrue: [
									"ctl-s"
									ctlKeyPressed := false]]).};
				callback: [ :value | classDefinition := value ];
				onChange: (scrpt html: [ :h | h render: self classDefinition ]) ] 
		on: html.
! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/28/2011 08:40'!
renderCommandsOn: html main: main

	self 
		renderCommandButton: #copyClass:id: label: 'Copy...' message: 'Copy... not implement' on: html main: main;
		renderCommandButton: #removeClass:id: label: 'Remove class...' message: 'Remove class... not implemented' on: html main: main;
		renderCommandButton: #renameClass:id: label: 'Rename...' message: 'Rename... not implemented' on: html main: main;
		yourself! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/23/2011 23:55'!
renderContentOn: html main: main

	self renderClassHeading: self actualClass on: html main: main.
	html break; break.
	self renderCommandsOn: html main: main.
	html break.
	self renderDefinitionTypeChoiceOn: html main: main.
	html break.
	self classTemplate == #explorer
		ifTrue: [ self renderClassExplorerOn: html main: main ]
		ifFalse: [ self renderClassDefinitionOn: html main: main ]
! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/28/2011 08:45'!
renderDefinitionTypeChoiceLink: definitionType label: label on: html main: main
	self
		renderButton: [ :s | 
			classTemplate := definitionType.
			classDefinition := nil.
			main updateCenterSideHistory: s ]
		label: label
		on: html.
! !

!TOClassBrowser methodsFor: 'rendering' stamp: 'dkh 5/28/2011 08:45'!
renderDefinitionTypeChoiceOn: html main: main
	| type |
	type := self classTemplate.
	html break.
	type ~~ #explorer
		ifTrue: [ self renderDefinitionTypeChoiceLink: #explorer label: 'Class explorer' on: html main: main ]
		ifFalse: [ html text: 'Class explorer'; space ].
	type ~~ #definition
		ifTrue: [ self renderDefinitionTypeChoiceLink: #definition label: 'Class definition' on: html main: main ]
		ifFalse: [ html text: 'Class definition'; space ].
	type ~~ #new
		ifTrue: [ self renderDefinitionTypeChoiceLink: #new label: 'New class template' on: html main: main ]
		ifFalse: [ html text: 'New class template'; space ].
	type ~~ #subclass
		ifTrue: [ self renderDefinitionTypeChoiceLink: #subclass label: 'Subclass template' on: html main: main ]
		ifFalse: [ html text: 'Subclass template'; space ].
! !

!TOClassBrowser methodsFor: 'events' stamp: 'dkh 5/26/2011 13:49'!
selectedSuperclassChanged

	super selectedSuperclassChanged.
	classDefinition := nil! !

TOCodeBrowser subclass: #TOClassHierarchy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOClassHierarchy methodsFor: 'rendering' stamp: 'dkh 5/28/2011 11:07'!
renderContentOn: html main: main
	| order classes indents displayBlock displayString |
	order := SortedCollection
		sortBlock: [ :assoc1 :assoc2 | 
			| result chain1 chain2 max i |
			result := nil.
			chain1 := assoc1 key.
			chain2 := assoc2 key.
			max := chain1 size min: chain2 size.
			i := 1.
			[ result isNil and: [ i <= max ] ]
				whileTrue: [ 
					(chain1 at: i) = (chain2 at: i)
						ifTrue: [ i := i + 1 ]
						ifFalse: [ result := (chain1 at: i) name < (chain2 at: i) name ] ].
			result isNil
				ifTrue: [ chain1 size < chain2 size ]
				ifFalse: [ result ] ].
	classes := (self theClass == Object or: [self theClass == ProtoObject])
		ifTrue: [ {self theClass}]
		ifFalse: [self theClass withAllSubclasses, self theClass allSuperclasses].
	classes := classes size < 10
		ifTrue: [ classes asArray ]
		ifFalse: [ classes asSet ].
	classes
		do: [ :cl | 
			| supersChain |
			supersChain := cl withAllSuperclasses reversed.
			supersChain removeAllSuchThat: [ :class | (classes includes: class) not ].
			order add: supersChain contents -> cl ].
	indents := IdentityDictionary new.
	order do: [ :assoc | indents at: assoc value put: assoc key size - 1 ].
	classes := classes asArray sorted: [ :a :b | a name <= b name ].
	displayBlock := [ :cl |  ].
	order
		do: [ :assoc | 
			| cl |
			cl := assoc value.
			self
				renderLink: [ :s | 
					main currentSpace push: cl selecting: #classBrowser.
					main updateCenterSideHistory: s ]
				with: [ 
					(indents at: cl) * 2 timesRepeat: [ html space ].
					cl == self theClass
						ifTrue: [html strong: cl name asString]
						ifFalse: [html text: cl name asString].
					html break ]
				on: html ]! !

!TOCodeBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:43'!
actualClass

	self object isBehavior
		ifTrue: [ ^self object ].
	^super actualClass! !

!TOCodeBrowser methodsFor: 'rendering' stamp: 'dkh 5/28/2011 13:31'!
renderCommandButton: commandSelector label: label message: message on: html main: main
	| id |
	(html div)
		id: (id := html nextId);
		script:
				((html jQuery new dialog)
						html: message;
						title: 'Information';
						resizable: false;
						modal: true).
	self
		renderButton: [ :s | 
			| aborted |
			aborted := false.
			[ 
			self
				perform: commandSelector
				withArguments:
					{s.
					id} ] on: TOAbortCommand do: [ :ex | aborted := true ].
			aborted
				ifFalse: [ main updateCenterSideHistory: s ] ]
		label: label
		on: html! !

!TOCodeBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:43'!
theClass

	^self selectedSuperclass ifNil: [ self actualClass ]! !

TOCodeBrowser subclass: #TOMethodBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOMethodBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 12:12'!
methodCategoryBrowser

	^ self frame properties
		at: #methodCategoryBrowser
		ifAbsent: [ 
			self frame properties
				at: #methodCategoryBrowser
				put:
					((TOMethodCategoryBrowser new)
						object: self object;
						frame: self frame;
						yourself) ]! !

!TOMethodBrowser methodsFor: 'accessing' stamp: 'dkh 5/29/2011 10:39'!
methodSourceBrowser
	^ self frame rendererForCenterTab: #methodSourceBrowser! !

!TOMethodBrowser methodsFor: 'rendering' stamp: 'dkh 5/26/2011 21:01'!
renderSuperclassHeading: aClass on: html main: main
	self sharedClassState
		renderSuperclassHeading: aClass
		renderName: [ :cl | 
			| sel |
			(sel := self selectedMethodSelector) isNil
				ifTrue: [ html strong: cl name ]
				ifFalse: [ 
					(cl includesSelector: sel)
						ifTrue: [ html emphasis: cl name ]
						ifFalse: [ html strong: cl name ] ] ]
		on: html
		main: main! !

!TOMethodBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 13:58'!
selectedMethodSelector

	^ self methodSourceBrowser selectedMethodSelector! !

TOMethodBrowser subclass: #TOMethodCategoryBrowser
	instanceVariableNames: 'selectedTab selectedSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOMethodCategoryBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 12:12'!
methodCategoryBrowser

	^self ! !

!TOMethodCategoryBrowser methodsFor: 'rendering' stamp: 'dkh 5/27/2011 09:38'!
renderContentOn: html main: main
	(html div)
		id: 'methodCategories';
		script:
				((html jQuery new accordion)
						fillSpace: false;
						autoHeight: false;  
						collapsible: true;
						active: 0
						);
		with: [ 
					html div: [ html anchor: '-- all --' ].
					html div: [ self renderMethodCategory: '-- all --' on: html main: main ].
					self sortedCategories
						do: [ :name | 
							html div: [ html anchor: name ].
							html div: [ self renderMethodCategory: name on: html main: main ] ] ]! !

!TOMethodCategoryBrowser methodsFor: 'rendering' stamp: 'dkh 5/27/2011 09:15'!
renderMethodCategory: cat on: html main: main
	| methods |
	methods := self selectorsForCategory: cat.
	(methods sorted: [ :a :b | a <= b ])
		do: [ :selector | 
			| anchor |
			(anchor := html anchor)
				url: '#';
				onClick:
						(html jQuery ajax
								script: [ :s | 
									selectedSelector := selector.
									self methodSourceBrowser methodReference: (MethodReference class: self theClass selector: selectedSelector).
									main
										updateCenterOn: s;
										updateSidebarOn: s ]);
				yourself.
			self selectedSelector == selector
				ifTrue: [ anchor with: [ :r | r strong: selector asString ] ]
				ifFalse: [ anchor with: selector asString ].
			html break ]! !

!TOMethodCategoryBrowser methodsFor: 'private' stamp: 'dkh 5/26/2011 14:43'!
selectCategory: aMethodCategory
	| cats |
	cats := self sortedCategories.
	1 to: cats size do: [:index |
		(cats at: index) == aMethodCategory ifTrue: [ ^selectedTab := index ]].
	^self selectedTab! !

!TOMethodCategoryBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 14:00'!
selectedMethodSelector

	^self selectedSelector ! !

!TOMethodCategoryBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 12:17'!
selectedSelector
	^ selectedSelector! !

!TOMethodCategoryBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 12:17'!
selectedSelector: anObject
	selectedSelector := anObject! !

!TOMethodCategoryBrowser methodsFor: 'events' stamp: 'dkh 5/27/2011 11:00'!
selectedSuperclassChanged
	super selectedSuperclassChanged.
	self selectCategory: (self theClass whichCategoryIncludesSelector: self selectedSelector).
	self methodSourceBrowser
		methodReference:
			((self theClass includesSelector: self selectedSelector)
				ifTrue: [ MethodReference class: self theClass selector: self selectedSelector ])! !

!TOMethodCategoryBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 14:40'!
selectedTab

	selectedTab ifNil: [ selectedTab := 0].
	^selectedTab ! !

TOMethodBrowser subclass: #TOMethodSourceBrowser
	instanceVariableNames: 'methodTemplate methodSource methodReference'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/30/2011 13:22'!
methodCategory

	^self methodReference category! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/30/2011 13:22'!
methodClass

	^self methodReference actualClass! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:51'!
methodReference
	^ methodReference! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:51'!
methodReference: anObject
	methodReference := anObject.
	methodSource := nil! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/30/2011 12:33'!
methodSource
	methodSource ifNil: [ methodSource := self originalSource ].
	^ methodSource! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 12:13'!
methodSourceBrowser

	^self! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 14:44'!
methodTemplate
	"#explorer, #editor"
	
	methodTemplate ifNil: [ methodTemplate := #editor ].
	^methodTemplate ! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/30/2011 12:32'!
originalSource
	^ self methodReference
		ifNil: [ 
			methodSource := 'messageSelectorAndArgumentNames
	"comment stating purpose of message"

	| temporary variable names |
	statements' ]
		ifNotNil: [ methodSource := self methodReference sourceCode ]! !

!TOMethodSourceBrowser methodsFor: 'rendering' stamp: 'dkh 5/29/2011 17:42'!
renderCommandsOn: html main: main
	| sel |
	((sel := self selectedMethodSelector) notNil and: [self object class == self actualClass])
		ifTrue: [ 
			self
				renderCommandButton: #sendSelectedMessageToSelf:id:
				label: 'Send ' , sel printString
				message: '???'
				on: html
				main: main ]! !

!TOMethodSourceBrowser methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:53'!
renderContentOn: html main: main

	self renderClassHeading: self actualClass on: html main: main.
	html break; break.
	self renderCommandsOn: html main: main.
	html break.
	self renderDefinitionTypeChoiceOn: html main: main.
	html break.
	self methodTemplate == #explorer
		ifTrue: [ self renderMethodExplorerOn: html main: main ]
		ifFalse: [ self renderMethodSourceOn: html main: main ]
! !

!TOMethodSourceBrowser methodsFor: 'rendering' stamp: 'dkh 5/28/2011 11:50'!
renderDefinitionTypeChoiceLink: definitionType label: label on: html main: main

	self
		renderButton: [ :s | 
			methodTemplate := definitionType.
			methodSource := nil.
			main updateCenterSideHistory: s ]
		label: label
		on: html.
	html space
! !

!TOMethodSourceBrowser methodsFor: 'rendering' stamp: 'dkh 5/26/2011 14:46'!
renderDefinitionTypeChoiceOn: html main: main
	| type |
	type := self methodTemplate.
	html break.
	type ~~ #explorer
		ifTrue: [ self renderDefinitionTypeChoiceLink: #explorer label: 'explorer' on: html main: main ]
		ifFalse: [ html text: 'explorer'; space ].
	type ~~ #editor
		ifTrue: [ self renderDefinitionTypeChoiceLink: #editor label: 'editor' on: html main: main ]
		ifFalse: [ html text: 'editor'; space ].
! !

!TOMethodSourceBrowser methodsFor: 'rendering' stamp: 'dkh 5/24/2011 01:57'!
renderMethodExplorerOn: html main: main
	self renderControl: [ :id :scrpt |  ] on: html! !

!TOMethodSourceBrowser methodsFor: 'rendering' stamp: 'dkh 5/30/2011 13:58'!
renderMethodSourceOn: html main: main
	self
		renderControl: [ :id :scrpt | 
			| imageId |
			(html textArea)
				id: id;
				columns: (self textAreaColumns: self methodSource);
				rows: (self textAreaRows: self methodSource);
				value: self methodSource;
				callback: [ :value | methodSource := value ];
				onChange:
						((html jQuery ajax)
								callback: [ :value | methodSource := value ] value: (html jQuery id: id) value).
			html break.
			(html submitButton)
				onClick:
						(html jQuery ajax
								callback: [ :value | 
									self accept: value.
									(html jQuery id: id) value: self methodSource]
									value: (html jQuery id: id) value;
					script: [:s | 
						main updateCenterSideHistory: s]);
				with: 'Save'.
			html space.
			(html image)
				id: (imageId := html nextId);
				height: 8;
				width: 8;
				url: self sourceChangedUrl.
			html space.
			(html cancelButton)
				callback: [ :value | methodSource := self originalSource ];
				onClick: ((html jQuery id: id) value: self originalSource);
				with: 'Cancel' ]
		on: html! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/26/2011 13:59'!
selectedMethodSelector

	self methodReference ifNil: [ ^nil ].
	^self methodReference methodSymbol  ! !

!TOMethodSourceBrowser methodsFor: 'commands' stamp: 'dkh 5/28/2011 13:04'!
sendSelectedMessageToSelf: s id: id

	| res |
	res := self object perform: self selectedMethodSelector.
	self frame space push: res selecting: #inspect! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/30/2011 12:52'!
sourceChanged

	^self methodSource ~= self originalSource! !

!TOMethodSourceBrowser methodsFor: 'accessing' stamp: 'dkh 5/30/2011 13:10'!
sourceChangedUrl
	^ self sourceChanged
		ifTrue: [ TOJQueryLibrary urlOf: #redButtonJpg ]
		ifFalse: [ TOJQueryLibrary urlOf: #greenButtonJpg ]! !

TOCodeBrowser subclass: #TOWorkspace
	instanceVariableNames: 'contents selection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOWorkspace methodsFor: 'accessing' stamp: 'dkh 5/27/2011 09:46'!
contents

	contents ifNil: [ contents := ''].
	^ contents! !

!TOWorkspace methodsFor: 'accessing' stamp: 'dkh 5/27/2011 09:46'!
contents: anObject
	contents := anObject! !

!TOWorkspace methodsFor: 'rendering' stamp: 'dkh 5/28/2011 13:37'!
renderContentOn: html main: main

	| start end |
	self 
		renderControl: [ :id :scrpt |
			html textArea
				id: id;
				columns: (80 max: (self textAreaColumns: self contents));
				rows: (20 max: (self textAreaRows: self contents));
				value: self contents;
				onChange: (scrpt html: [ :h | h render: self contents ]);
				onSelect: (html jQuery ajax
					callback: [ :value | start := value] value: (JSStream on: 'selectionStart');
					callback: [ :value | end := value] value: (JSStream on: 'selectionEnd');
					callback: [ :value | selection := value copyFrom: start + 1 to: end.] value: (html jQuery id: id) value;
					yourself).
			html break.
			html submitButton
            		onClick: (html jQuery ajax
               			callback: [ :value | contents := value ] value: (html jQuery id: id) value);
            		with: 'Save'.
			html cancelButton
            		onClick: ((html jQuery id: id) value: self contents);
            		with: 'Cancel'.
			html submitButton
            		onClick: (html jQuery ajax
					callback: [ :value | ] value: (html jQuery id: id) value;
					script: [:s | 
						[self doit: selection main: main] on: TOErrorCommand do: [:ex |
						main updateCenterSideHistory: s]]);
            		with: 'Selection doit '.
			html submitButton
            		onClick: (html jQuery ajax
					callback: [ :value | self inspectit: selection main: main ] value: (html jQuery id: id) value;
					script: [:s | 
						main updateCenterSideHistory: s]);
            		with: 'Selection inspect '.
 ]
		on: html.
! !

TOView subclass: #TODebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TODebugger methodsFor: 'accessing' stamp: 'dkh 5/29/2011 11:04'!
tODEDebugFrameSidebarSpec

	^ {(TOTabSpec new)
		id: #debug;
		renderer: self;
		receiver: self;
		label: 'stack';
		order: 50;
		group: 'basic';
		renderSelector: #renderStackOn:spec:main:}! !

!TODebugger methodsFor: 'accessing' stamp: 'dkh 5/29/2011 11:02'!
tODEDebugFrameTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #debug;
		renderer: self;
		receiver: self;
		label: 'debug';
		order: 75;
		group: 'basic';
		sidebarSpec: self tODEDebugFrameSidebarSpec;
		renderSelector: #renderContentOn:spec:main:! !

TODebugger subclass: #TOException
	instanceVariableNames: 'frames topOfStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOException methodsFor: 'accessing' stamp: 'dkh 5/28/2011 13:42'!
exception

	^self object! !

!TOException methodsFor: 'accessing' stamp: 'dkh 5/28/2011 17:35'!
frames

	^frames! !

!TOException methodsFor: 'rendering' stamp: 'dkh 5/30/2011 13:33'!
renderContentOn: html spec: aTOTabSpec main: main
	self frame: aTOTabSpec frame.
	html text: 'An '.
	self
		renderLink: [ :s | 
			main currentSpace push: self exception selecting: #inspect.
			main updateCenterSideHistory: s ]
		with: 'exception'
		on: html.
	html text: ':'.
	html
		unorderedList: [ 
			(html heading)
				level: 1;
				with: self exception description ].
	html paragraph: ' has occurred during the execution of the script.'.
	html
		paragraph: [ 
			html text: 'To debug, select '.
			self
				renderLink: [ :s | 
					main currentSpace push: self topOfStack selecting: #debug.
					main updateCenterSideHistory: s ]
				with: 'topOfStack'
				on: html.
			html text: ' or a frame from the list on your left.' ]! !

!TOException methodsFor: 'rendering' stamp: 'dkh 5/29/2011 17:24'!
renderStackOn: html spec: aTOSpec main: main

	self renderStackOn: html stackFrame: self main: main
! !

!TOException methodsFor: 'rendering' stamp: 'dkh 5/29/2011 11:32'!
renderStackOn: html stackFrame: aStackFrame main: main

	self frames do: [:fr |
		 | anchor |
			(anchor := html anchor)
				url: '#';
				onClick:
						(html jQuery ajax
								script: [ :s |
									self pushit: fr selecting: #debug main: main.
									main updateCenterSideHistory: s]);
				yourself.
			aStackFrame == fr
				ifTrue: [ anchor with: [:r | r strong: fr printString ]]
				ifFalse: [ anchor with: fr printString ].
			html break. ]! !

!TOException methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:49'!
topOfStack

	^topOfStack! !

TODebugger subclass: #TOStackFrame
	instanceVariableNames: 'exception previous context next receiver stackHome'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
context
	^ context! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
context: anObject

	receiver := anObject receiver.
	context := anObject! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:54'!
exception
	^ exception! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:54'!
exception: anObject
	exception := anObject! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 20:29'!
home

	| home stackFrame  |
	stackHome ifNotNil: [ ^stackHome ].
	(home := self context home) == self context
		ifTrue: [ ^stackHome := nil ].
	stackFrame := self next.
	[ stackFrame notNil ] whileTrue: [
		stackFrame context home == home ifTrue: [ ^stackHome := stackFrame ].
		stackFrame := stackFrame next ].
	^stackHome := nil! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 20:16'!
methodClass

	^(self receiverClass whichClassIncludesSelector: self methodSelector) ifNil: [self receiverClass]! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 20:17'!
methodSelector

	^self context method selector! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 19:05'!
methodSource

	^self context sourceCode! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
next
	^ next! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
next: anObject
	next := anObject! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
previous
	^ previous! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:14'!
previous: anObject
	previous := anObject! !

!TOStackFrame methodsFor: 'printing' stamp: 'dkh 5/28/2011 18:14'!
printContext: aContext on: aStream
	aContext outerContext
		ifNil: [aContext  printOn: aStream]
		ifNotNil:
			[:outerContext|
			 aStream nextPutAll: ' [] in '.
			 self printContext: outerContext on: aStream]! !

!TOStackFrame methodsFor: 'printing' stamp: 'dkh 5/28/2011 18:14'!
printOn: aStream
	self printContext: self context on: aStream! !

!TOStackFrame methodsFor: 'accessing' stamp: 'dkh 5/28/2011 20:16'!
receiverClass

	^self context receiver class! !

!TOStackFrame methodsFor: 'rendering' stamp: 'dkh 5/29/2011 11:02'!
renderContentOn: html spec:  aTOTabSpec main: main
	self frame: aTOTabSpec frame.
	self renderFrameNavigationOn: html main: main.
	html break.
	html strong: self printString.
	html break.
	self renderMethodSourceOn: html main: main.
	html horizontalRule.
	((TOContextInspector new)
		object: self context;
		frame:  aTOTabSpec frame) renderMembersOn: html main: main.
	html horizontalRule.
	((TOReceiverInspector new)
		receiver: self context receiver;
		frame:  aTOTabSpec frame) renderMembersOn: html main: main.
! !

!TOStackFrame methodsFor: 'rendering' stamp: 'dkh 5/29/2011 07:50'!
renderFrameNavigationOn: html main: main
	self
		renderButton: [ :s | 
			main currentSpace push: self exception selecting: #debug.
			main updateCenterSideHistory: s ]
		label: 'exception'
		on: html.
	html break.
	self previous isNil
		ifTrue: [ html text: '<<' ]
		ifFalse: [ 
			self
				renderButton: [ :s | 
					main currentSpace push: self previous selecting: #debug.
					main updateCenterSideHistory: s ]
				label: '<<'
				on: html ].
	html text: ' frames '.
	self next isNil
		ifTrue: [ html text: '>>' ]
		ifFalse: [ 
			self
				renderButton: [ :s | 
					main currentSpace push: self next selecting: #debug.
					main updateCenterSideHistory: s ]
				label: '>>'
				on: html ].
	self home
		ifNotNil: [ :home | 
			self
				renderButton: [ :s | 
					main currentSpace push: self home selecting: #debug.
					main updateCenterSideHistory: s ]
				label: 'home context'
				on: html ].
	html break! !

!TOStackFrame methodsFor: 'rendering' stamp: 'dkh 5/30/2011 13:27'!
renderMethodSourceOn: html main: main
	
	| cat |
	self 
		renderControl: [ :id :scrpt |
			html textArea
				id: id;
				columns: (self textAreaColumns: self methodSource);
				rows: (self textAreaRows: self methodSource);
				value: self methodSource ] 
		on: html.
! !

!TOStackFrame methodsFor: 'rendering' stamp: 'dkh 5/29/2011 11:32'!
renderStackOn: html spec: aTOTabSpec main: main

	self exception renderStackOn: html stackFrame: self main: main! !

TOView subclass: #TOInspector
	instanceVariableNames: 'basicInspect toggleVisible basicMembers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

TOInspector subclass: #TOContextInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOContextInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 08:25'!
context

	^self object! !

!TOContextInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 08:25'!
context: anObject

	self object: anObject! !

!TOContextInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 08:34'!
getContextMembers
	| members tempNames |
	members := OrderedCollection new.
	members
		add:
			((TOInspectorKeylessFieldSpec new)
				keyLabel: 'thisContext';
				value: self context).
	tempNames := self context tempNames.
	self context numArgs + 1 to: tempNames size do: [ :index | 
		members
			add:
				((TOInspectorKeylessFieldSpec new)
					keyLabel: (tempNames at: index);
					value: (self context debuggerMap namedTempAt: index in: self context)) ].
	^ members! !

!TOContextInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 08:41'!
renderMembersOn: html main: main
	html strong: 'Args:'.
	html unorderedList: [self renderBasicMembers: self getArgMembers on: html main: main].
	html strong: 'Method Context:' .
	html unorderedList: [self renderBasicMembers: self getContextMembers on: html main: main].
! !

!TOInspector methodsFor: 'private' stamp: 'dkh 5/23/2011 23:28'!
basicFieldsFor: anObject

	(Pragma allNamed: #tODEBasicInspectorFields from: anObject class to: nil) do: [:pragma |
		^anObject perform: pragma method selector ].
	^#()! !

!TOInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 09:28'!
basicInspect

	^basicInspect! !

!TOInspector methodsFor: 'accessing' stamp: 'dkh 5/28/2011 18:47'!
basicMembers

	^basicMembers! !

!TOInspector methodsFor: 'private' stamp: 'dkh 5/23/2011 23:28'!
fieldsFor: anObject

	(Pragma allNamed: #tODEInspectorFields from: anObject class to: nil) do: [:pragma |
		^anObject perform: pragma method selector ].
	^#()! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/23/2011 09:25'!
getMembers
	| members |
	basicMembers := toggleVisible := true.
	basicInspect
		ifTrue: [ members := self basicFieldsFor: self object ]
		ifFalse: [ 
			members := self fieldsFor: self object.
			members isEmpty
				ifTrue: [ 
					members := self basicFieldsFor: self object.
					toggleVisible := false ]
				ifFalse: [ basicMembers := false ] ].
	^ members! !

!TOInspector methodsFor: 'initialize-release' stamp: 'dkh 5/23/2011 09:25'!
initialize

	super initialize.
	basicInspect := toggleVisible := basicMembers := false.! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 08:14'!
renderBasicMembers: members on: html main: main
	members
		do: [ :fieldSpec | 
			fieldSpec hasKey
				ifTrue: [ 
					self
						renderLink: [ :s | 
							main currentSpace push: fieldSpec key selecting: fieldSpec keySelectedTab.
							main updateCenterSideHistory: s ]
						with: fieldSpec keyLabel
						on: html.
					html text: ' -> ' ]
				ifFalse: [ fieldSpec keyLabel ifNotNil: [ html text: fieldSpec keyLabel , ' -> ' ] ].
			fieldSpec hasValue
				ifTrue: [ 
					self
						renderLink: [ :s | 
							main currentSpace push: fieldSpec value selecting: fieldSpec valueSelectedTab.
							main updateCenterSideHistory: s ]
						with: fieldSpec valueLabel
						on: html ]
				ifFalse: [ html preformatted: fieldSpec valueLabel ].
			html break ]! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/28/2011 08:44'!
renderBasicToggleOn: html main: main
	toggleVisible
		ifTrue: [ 
			self
				renderButton: [ :s | 
					basicInspect := basicInspect not.
					main updateCenterOn: s ]
				label:
					(basicInspect
						ifTrue: [ 'standard inspector' ]
						ifFalse: [ 'basic inspector' ])
				on: html.
			html break ]! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 09:23'!
renderContentOn: html main: main
	self object renderInspectorContentOn: html for: self main: main! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/28/2011 11:28'!
renderExtraInspectorContentOn: html main: main

	(Pragma allNamed: #tODEInspectorExtraRendering from: self object class to: nil) do: [:pragma |
		^self object perform: pragma method selector withArguments:  {html. main}].
	^#()! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 08:22'!
renderMembers: members on: html main: main
	self
		renderBasicMembers:
			{((TOInspectorKeylessFieldSpec new)
				keyLabel: 'self';
				value: self object)}
		on: html
		main: main.
	html horizontalRule .
	basicMembers
		ifFalse: [ self renderExtraInspectorContentOn: html main: main ].
	self renderBasicMembers: members on: html main: main! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 08:08'!
renderMembersOn: html main: main
	self renderMembers: self getMembers on: html main: main! !

!TOInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 09:23'!
renderStandardContentOn: html main: main
	| members classText actualClass |
	members := self getMembers.
	actualClass := self actualClass.
	classText := self object isBehavior
		ifTrue: [ 'the Class ' , actualClass name ]
		ifFalse: [ 'an instance of ' , actualClass name ].
	(html heading)
		level: 3;
		with:
				(basicMembers
						ifTrue: [ 'Basic Inspector on ' , classText ]
						ifFalse: [ 'Inspector on ' , classText ]).
	self renderBasicToggleOn: html main: main.
	html break.
	self renderMembers: members on: html main: main! !

TOInspector subclass: #TOReceiverInspector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOReceiverInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 08:42'!
receiver

	^self object! !

!TOReceiverInspector methodsFor: 'accessing' stamp: 'dkh 5/29/2011 08:42'!
receiver: anObject

	self object: anObject! !

!TOReceiverInspector methodsFor: 'rendering' stamp: 'dkh 5/29/2011 08:44'!
renderMembersOn: html main: main
	html strong: 'Self:'.
	html unorderedList: [super renderMembersOn: html main: main].
! !

TOView subclass: #TOSharedClassState
	instanceVariableNames: 'selectedSuperclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOSharedClassState methodsFor: 'rendering' stamp: 'dkh 5/26/2011 20:57'!
renderSuperclassHeading: aClass on: html main: main
	self
		renderSuperclassHeading: aClass
		renderName: [:cl | html strong: cl name ]
		whenClicked: [self selectedSuperclassChanged]
		on: html
		main: main! !

!TOSharedClassState methodsFor: 'rendering' stamp: 'dkh 5/26/2011 20:55'!
renderSuperclassHeading: aClass renderName: renderNameBlock on: html main: main
	self
		renderSuperclassHeading: aClass
		renderName: renderNameBlock
		whenClicked: [ self selectedSuperclassChanged ]
		on: html
		main: main! !

!TOSharedClassState methodsFor: 'rendering' stamp: 'dkh 5/26/2011 20:57'!
renderSuperclassHeading: aClass renderName: renderNameBlock whenClicked: aBlock on: html main: main
	html text: 'Superclasses: '.
	aClass allSuperclasses reversed
		do: [ :supClass | 
			supClass == self selectedSuperclass
				ifTrue: [ renderNameBlock value: supClass ]
				ifFalse: [ 
					self
						renderLink: [ :s | 
							self selectedSuperclass: supClass.
							aBlock value.
							main updateCenterSideHistory: s ]
						with: [ renderNameBlock value: supClass ]
						on: html ].
			html text: '->' ].
	self selectedSuperclass == nil
		ifTrue: [ renderNameBlock value: aClass ]
		ifFalse: [ 
			self
				renderLink: [ :s | 
					self selectedSuperclass: nil.
					aBlock value.
					main updateCenterSideHistory: s ]
				with: [ renderNameBlock value: aClass ]
				on: html ]! !

!TOSharedClassState methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:11'!
selectedSuperclass
	^ selectedSuperclass! !

!TOSharedClassState methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:11'!
selectedSuperclass: anObject
	^ selectedSuperclass := anObject! !

!TOSharedClassState methodsFor: 'events' stamp: 'dkh 5/29/2011 10:15'!
selectedSuperclassChanged
	#(#methodSourceBrowser #methodCategoryBrowser #classBrowser)
		do: [ :id | frame properties at: id ifPresent: [ :view | view selectedSuperclassChanged ] ]! !

TOView subclass: #TOTestCase
	instanceVariableNames: 'testResults suite'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOTestCase methodsFor: 'accessing' stamp: 'dkh 5/29/2011 15:21'!
greenButton! !

!TOTestCase methodsFor: 'rendering' stamp: 'dkh 5/29/2011 17:31'!
renderContentOn: html main: main
	| testClasses classes passed failures errors |
	self testCase isAbstract
		ifTrue: [ ^ html text: 'I am an abstract TestCase ... no tests' ].
	testClasses := (classes := {(self testCase)} , self testCase allSuperclasses)
		copyFrom: 1
		to: (classes indexOf: TestCase).
	suite
		ifNil: [ 
			suite := TestSuite new.
			testClasses
				do: [ :each | 
					each isAbstract
						ifFalse: [ each addToSuiteFromSelectors: suite ] ] ].
	self
		renderButton: [ :s | 
			testResults := suite run.
			main updateCenterSideHistory: s ]
		label: 'run all'
		on: html.
	html horizontalRule.
	passed := failures := errors := #().
	self testResults
		ifNotNil: [ 
			html text: self testResults printString.
			html horizontalRule.
			passed := self testResults passed.
			failures := self testResults failures.
			errors := self testResults errors ].
	suite tests
		do: [ :testCase | 
			(passed includes: testCase)
				ifTrue: [ 
					(html image)
						height: 12;
						width: 12;
						url: (TOJQueryLibrary urlOf: #greenButtonJpg) ]
				ifFalse: [ 
					(html image)
						height: 12;
						width: 12;
						url: (TOJQueryLibrary urlOf: #redButtonJpg) ].
			html space.
			self
				renderLink: [ :s | 
					self handleExceptions: TestFailure during: [ testCase debug ] main: main.
					main updateCenterSideHistory: s ]
				with: testCase printString
				on: html.
			html break ]! !

!TOTestCase methodsFor: 'accessing' stamp: 'dkh 5/29/2011 14:50'!
testCase

	^self object! !

!TOTestCase methodsFor: 'accessing' stamp: 'dkh 5/29/2011 14:57'!
testResults

	^testResults! !

!MethodReference methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 11:22'!
renderInspectorContentOn: html for: aTOInspector main: main
	aTOInspector getMembers.
	aTOInspector basicInspect
		ifTrue: [ ^ aTOInspector renderStandardContentOn: html main: main ].
	aTOInspector renderBasicToggleOn: html main: main.
	html horizontalRule.
	aTOInspector
		renderLink: [ :s | 
			main currentSpace push: self methodClass selecting: #classBrowser.
			main updateCenterSideHistory: s ]
		with: [html strong: self methodClass name]
		on: html.
	html text: '>>'.
	aTOInspector
		renderLink: [ :s | | fr |
			fr := main currentSpace push: self methodClass selecting: #methodSourceBrowser.
			main updateCenterSideHistory: s ]
		with: [html strong: self methodSymbol]
		on: html.
	html break.
	(html textArea)
		readonly: true;
		columns: (aTOInspector textAreaColumns: self sourceString);
		rows: (aTOInspector textAreaRows: self sourceString);
		value: self sourceString! !

!MethodReference methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 13:50'!
tODEInspectorFields
	<tODEInspectorFields>
	"force inspector to have standard and basic views"
	^self tODEBasicInspectorFields! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 10:42'!
renderClassSidebarOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 10:56'!
renderClassTabOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 10:48'!
renderHelpTabOn: html spec: aTOTabSpec tOdeMain: main
	aTOTabSpec renderer ~~ self
		ifTrue: [ ^ aTOTabSpec renderer renderContentOn: html main: main ].
	self isBehavior
		ifTrue: [ 
			(html heading)
				level: 3;
				with: 'I am the Class ' , self name.
			html preformatted: self comment ]
		ifFalse: [ 
			(html heading)
				level: 3;
				with: 'I am an instance of ' , self class name.
			html preformatted: self class comment ]! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 10:54'!
renderInspectorContentOn: html for: aTOInspector main: main
	"Callback to allow receiver to customize the standard (as opposed to basic) inspector view"
	
	aTOInspector renderStandardContentOn: html main: main! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 10:51'!
renderInspectorTabOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 10:41'!
renderMethodSidebarOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 10:35'!
renderMethodTabOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 10:57'!
renderWorkspaceTabOn: html spec: aTOTabSpec tOdeMain: main

	aTOTabSpec renderer renderContentOn: html main: main! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/28/2011 11:12'!
tODEBasicInspectorFields
	<tODEBasicInspectorFields>
	| members noMembers |
	members := WriteStream on: Array new.
	noMembers := true.
	self class allInstVarNames
		keysAndValuesDo: [ :index :each | 
			noMembers := false.
			members
				nextPut:
					((TOInspectorKeylessFieldSpec new)
						keyLabel: each asString;
						value: (self instVarAt: index)) ].
	self class isVariable
		ifTrue: [ 
			1 to: self basicSize do: [ :index | 
				noMembers := false.
				members
					nextPut:
						((TOInspectorKeylessFieldSpec new)
							keyLabel: index printString;
							value: (self basicAt: index)) ] ].
	noMembers
		ifTrue: [ members nextPut: (TOInspectorValuelessFieldSpec new valueLabel: self printString) ].
	^ members contents! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 10:41'!
tODEClassSidebarSpec

	^ {(TOTabSpec new)
		id: #classHierarchy;
		rendererClass: TOClassHierarchy;
		receiver: self;
		label: 'subclasses';
		order: 50;
		group: 'development';
		renderSelector: #renderClassSidebarOn:spec:tOdeMain:}! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 10:56'!
tODEClassTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #classBrowser;
		rendererClass: TOClassBrowser;
		receiver: self;
		label: 'class';
		order: 25;
		group: 'development';
		sidebarSpec: self tODEClassSidebarSpec;
		renderSelector: #renderClassTabOn:spec:tOdeMain:! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 10:49'!
tODEHelpTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #help;
		renderer: self;
		receiver: self;
		label: 'help';
		order: 25;
		group: 'basic';
		renderSelector: #renderHelpTabOn:spec:tOdeMain:! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 10:50'!
tODEInspectorTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #inspect;
		rendererClass: TOInspector;
		receiver: self;
		label: 'inspect';
		order: 50;
		group: 'basic';
		renderSelector: #renderInspectorTabOn:spec:tOdeMain:! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 10:40'!
tODEMethodSidebarSpec

	^ {(TOTabSpec new)
		id: #methodCategoryBrowser;
		rendererClass: TOMethodCategoryBrowser;
		receiver: self;
		label: 'method categories';
		order: 50;
		group: 'development';
		renderSelector: #renderMethodSidebarOn:spec:tOdeMain:}! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 10:36'!
tODEMethodTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #methodSourceBrowser;
		rendererClass: TOMethodSourceBrowser;
		receiver: self;
		label: 'method';
		order: 50;
		group: 'development';
		sidebarSpec: self tODEMethodSidebarSpec;
		renderSelector: #renderMethodTabOn:spec:tOdeMain:! !

!Object methodsFor: '*tode-views' stamp: 'dkh 5/29/2011 10:57'!
tODEWorksapceTabSpec
	<tODECenterTabSpec>

	^ (TOTabSpec new)
		id: #workspace;
		rendererClass: TOWorkspace;
		receiver: self;
		label: 'workspace';
		order: 75;
		group: 'development';
		renderSelector: #renderWorkspaceTabOn:spec:tOdeMain:! !

Object subclass: #TOInspectorFieldSpec
	instanceVariableNames: 'keyLabel key keySelectedTab valueLabel value valueSelectedTab'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOInspectorFieldSpec methodsFor: 'testing' stamp: 'dkh 5/28/2011 10:26'!
hasKey

	^true! !

!TOInspectorFieldSpec methodsFor: 'testing' stamp: 'dkh 5/28/2011 10:38'!
hasValue

	^true! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:57'!
key
	^ key! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:57'!
key: anObject
	key := anObject! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:02'!
keyLabel
	keyLabel ifNil: [^self key printStringLimitedTo: 50].
	^ keyLabel! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:58'!
keyLabel: anObject
	keyLabel := anObject! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:04'!
keySelectedTab
	keySelectedTab ifNil: [ ^#inspect ].
	^ keySelectedTab! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:58'!
keySelectedTab: anObject
	keySelectedTab := anObject! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:59'!
value
	^ value! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:58'!
value: anObject
	value := anObject! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:02'!
valueLabel
	valueLabel ifNil: [^self value printStringLimitedTo: 50].
	^ valueLabel! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:58'!
valueLabel: anObject
	valueLabel := anObject! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:05'!
valueSelectedTab
	valueSelectedTab ifNil: [ ^#inspect ].
	^ valueSelectedTab! !

!TOInspectorFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 09:58'!
valueSelectedTab: anObject
	valueSelectedTab := anObject! !

TOInspectorFieldSpec subclass: #TOInspectorKeylessFieldSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOInspectorKeylessFieldSpec methodsFor: 'testing' stamp: 'dkh 5/28/2011 10:26'!
hasKey

	^false! !

!TOInspectorKeylessFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:36'!
keyLabel
	^ keyLabel! !

TOInspectorKeylessFieldSpec subclass: #TOInspectorValuelessFieldSpec
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOInspectorValuelessFieldSpec methodsFor: 'testing' stamp: 'dkh 5/28/2011 10:38'!
hasValue

	^false! !

!TOInspectorValuelessFieldSpec methodsFor: 'accessing' stamp: 'dkh 5/28/2011 10:38'!
valueLabel
	^ valueLabel! !

!String methodsFor: '*tode-views' stamp: 'dkh 5/28/2011 11:47'!
renderExtraContentOn: html tODEMain: main
	<tODEInspectorExtraRendering>
	"no extra fields"! !

!String methodsFor: '*tode-views' stamp: 'dkh 5/28/2011 10:37'!
tODEInspectorFields
	<tODEInspectorFields>
	^ {TOInspectorValuelessFieldSpec new valueLabel: self}! !
